<template>
  <li v-if="canViewVerticalNavMenuLink(item)" class="nav-item" :class="{
    active: isActive,
  }">
    <b-link @click="goToBack($route.meta, item)" class="d-flex align-items-center"
      v-if="$route.meta.type == 'create' || $route.meta.type == 'edit' || $route.meta.type == 'details'">
      <vertical-nav-icons v-if="item.iconComponent && item.iconComponent != ''" :icon="item.iconComponent" class="menu-icon-img" />
      <FeatherIcon v-else-if="item.icon" :icon="item.icon || 'CircleIcon'" />
      <img v-else-if="item.iconImage" :src="require('@/assets/images/icons/' + item.iconImage)" class="menu-icon-img" />
      <span class="menu-title text-truncate sidebar-title">{{ t(item.title) }}</span>
      <b-badge v-if="item.tag" pill :variant="item.tagVariant || 'primary'" class="mr-1 ml-auto">
        {{ item.tag }}
      </b-badge>
    </b-link>
    <b-link :to="{ name: item.route }" class="d-flex align-items-center"
      v-if="$route.meta.type != 'create' && $route.meta.type != 'edit' && $route.meta.type != 'details'">
      <vertical-nav-icons v-if="item.iconComponent && item.iconComponent != ''" :icon="item.iconComponent" class="menu-icon-img" />
      <FeatherIcon v-else-if="item.icon" :icon="item.icon || 'CircleIcon'" />
      <img v-else-if="item.iconImage" :src="require('@/assets/images/icons/' + item.iconImage)" class="menu-icon-img" />
      <span class="menu-title text-truncate sidebar-title">{{ t(item.title) }}</span>
      <b-badge v-if="item.tag" pill :variant="item.tagVariant || 'primary'" class="mr-1 ml-auto">
        {{ item.tag }}
      </b-badge>
    </b-link>

    <b-modal ref="goBackConfirmMenuModal" id="goBackConfirmMenuModal" size="sm" hide-footer>
      <div class="mt-1 convert-model">
        <center>
          <IconWarning class="tick-icon align-center"  />
          <h3>Go Back !</h3>
          <p>Are you sure you want to go back? Unsaved data will be lost!</p>
        </center>
        <center class="mt-2">
        
          <b-button class="btn-reset" variant="flat-secondary" type="button"
            @click="$bvModal.hide('goBackConfirmMenuModal')">
          No, Stay Here
          </b-button>
          <b-button class="btn-submit-edit" variant="primary" type="submit" @click="statusChangeConfirm()">
            Yes, Go Back
          </b-button>
          </center>
       </div>
    </b-modal>
  </li>
</template>

<script>
import { useUtils as useAclUtils } from "@core/libs/acl";
import { BLink, BBadge, BButton, BModal } from "bootstrap-vue";
import { useUtils as useI18nUtils } from "@core/libs/i18n";
import useVerticalNavMenuLink from "./useVerticalNavMenuLink";
import mixinVerticalNavMenuLink from "./mixinVerticalNavMenuLink";
import VerticalNavIcons from "./VerticalNavIcons.vue";
import router from "@/router";

export default {
  components: {
    BLink,
    BBadge,
    BButton,
    BModal,
    VerticalNavIcons,
  },

  mixins: [mixinVerticalNavMenuLink],
  props: {
    item: {
      type: Object,
      required: true,
    },
  },
  setup(props) {
    const { isActive, linkProps, updateIsActive } = useVerticalNavMenuLink(props.item);
    const { t } = useI18nUtils();
    const { canViewVerticalNavMenuLink } = useAclUtils();

    return {
      isActive,
      linkProps,
      updateIsActive,

      // ACL
      canViewVerticalNavMenuLink,

      // i18n
      t,
    };
  },

  data() {
    return {
    };
  },
  methods: {
    goToBack(route, item) {
      console.log('asdasdasdasdasdasdasdsd')
      if (route.type == "create" || route.type == "edit") {
        this.$refs["goBackConfirmMenuModal"].show();
      } else {
        if (
          router.currentRoute.query &&
          (router.currentRoute.query.mode == "create" ||
            router.currentRoute.query.mode == "edit")
        ) {
          this.$refs["goBackConfirmMenuModal"].show();
        } else {
          this.$refs["goBackConfirmMenuModal"].hide();
          this.$router.push({ name: item.route });
        }
      }
    },

    statusChangeConfirm() {
      this.$refs["goBackConfirmMenuModal"].hide();
      this.$router.push(this.linkProps.to);
    },
  },
};
</script>
